
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#import "kernel32.dll"
int  GetTimeZoneInformation(int& TZInfoArray[]);
#import

//
//
//
//
//

#define TIME_ZONE_ID_UNKNOWN   0
#define TIME_ZONE_ID_STANDARD  1
#define TIME_ZONE_ID_DAYLIGHT  2

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string ExpertName              = "nlma_hma_cross";
extern string Version                 = "nmc";

extern string _gen                    = "General Settings";
extern bool   EcnBroker               = true;
extern bool   UseAutoMagic            = true;
extern int    ManualMagic             = 46464665;  
extern double lStopLoss               = 100;
extern double sStopLoss               = 100;
extern double lTakeProfit             = 300;
extern double sTakeProfit             = 300;
extern double lTrailingStop           = 50;
extern double sTrailingStop           = 50;
extern double BreakEven               = 25;
extern int    LockInPips              = 25;        // Profit Lock in pips
extern bool   TrailAfterBreakEvenOnly = true;
extern int    Slippage                = 4;
extern double Lots                    = 0.1;
extern double MaximumRisk             = 0;
extern double DecreaseFactor          = 3;

extern string XX                      = "Indicators";       
extern int    NlmPeriod               = 15;
extern int    NlmPrice                = PRICE_CLOSE;
extern double PctFilter               = 0;
extern int    HmaPeriod               = 200;
extern int    HmaPrice                = PRICE_CLOSE;
extern int    currentbar              = 1;

extern bool   ShowWeeklyFibs          = true;
extern bool   Weekly_SR_Levels        = true;
extern bool   Weekly_Mid_Levels       = true;
extern color  Weekly_Pivot            = Goldenrod;
extern color  Weekly_S_Levels         = SteelBlue;
extern color  Weekly_R_Levels         = Crimson;
extern color  Weekly_Mid_Level        = DarkSlateGray;

extern string x                       = "Order Close Settings";
extern bool   CloseOnTrendChange      = false;

extern string tf                      = "Time Filter";
extern bool   UseHourTrade            = false;
extern int    StartHour               = 3;
extern int    StartMinute             = 0;
extern int    EndHour                 = 22;
extern int    EndMinute               = 0;

extern string __                      = "Setting for friday positions close";
extern bool   CloseOnFriday           = false;
extern int    FridayCloseHour         = 21; 
extern int    FridayCloseMinute       = 59; 

extern string os                      = "Other Stuff";
extern bool   ShowAlerts              = false;
extern bool   ShowComments            = true;   
extern color  clOpenBuy               = Blue;
extern color  clCloseBuy              = Aqua;
extern color  clOpenSell              = Red;
extern color  clCloseSell             = Violet;

//
//
//
//
//

string tc = "";
string s_symbol;

bool   dummyResult;

int    MAGIC;
int    digit;
int    TZInfoArray[43];

double pipMultiplier = 1;
double pPoint;
double WeekHigh;
double WeekLow;
double WeekClose;
double Weekly_Price[][6];
double WeekRange;
double W_day_high = 0;
double W_day_low  = 0;
double W_nQ = 0;
double W_nD = 0;
double W_D  = 0;
double W_Q  = 0;
double WeekPivot,WS1,WS2,WS3,WR1,WR2,WR3;
double WM1,WM2,WM3,WM4,WM5,WM6;  //weekly mid-pivots

//
//
//
//
//

int init() 
{
   s_symbol = Symbol();
   pPoint   = MarketInfo(s_symbol,MODE_POINT);
   digit    = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) pipMultiplier = 1;
   if (digit==3 || digit==5) pipMultiplier = 10;
   if (digit==6)             pipMultiplier = 100;
   
   //
   //
   //
   //
   //
   
   if (UseAutoMagic) MAGIC = GetMagic();
               else  MAGIC = ManualMagic;    
              
return(0);
}

//
//
//
//
//

int deinit() 
{ 
   Comment(""); 
   ObjectDelete("WeekPivotLine");

   ObjectDelete("WR1_Line");
   ObjectDelete("WR2_Line");
   ObjectDelete("WR3_Line");

   ObjectDelete("WS1_Line");
   ObjectDelete("WS2_Line");
   ObjectDelete("WS3_Line");  

   ObjectDelete("WM1_Line");
   ObjectDelete("WM2_Line");
   ObjectDelete("WM3_Line");
   ObjectDelete("WM4_Line");
   ObjectDelete("WM5_Line");
   ObjectDelete("WM6_Line");

   ObjectDelete("WeekPivotLabel");

   ObjectDelete("WR1_Label");
   ObjectDelete("WR2_Label");
   ObjectDelete("WR3_Label");

   ObjectDelete("WS1_Label");
   ObjectDelete("WS2_Label");
   ObjectDelete("WS3_Label");  

   ObjectDelete("WM1_Label");
   ObjectDelete("WM2_Label");
   ObjectDelete("WM3_Label");
   ObjectDelete("WM4_Label");
   ObjectDelete("WM5_Label");
   ObjectDelete("WM6_Label");
   
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (!IsDllsAllowed()) 
   {
     Alert("DLLs are disabled.  To enable  check the box in the tools/options/expert advisors on your chart");
     return(0);
   }
   
   if (BreakEven>0)        breakEvenManager();
   if (lTrailingStop > 0)  TrailingPositionsBuy();
   if (sTrailingStop > 0)  TrailingPositionsSell();
   if (CloseOnTrendChange) CheckForClose();
   if (ShowComments)       ChartComment();    
   
   //
   //
   //
   //
   //
   
   if (CloseOnFriday && TimeDayOfWeek(TimeCurrent())==5)
   {
     if (TimeHour(TimeCurrent()) > FridayCloseHour ||
        (TimeHour(TimeCurrent())== FridayCloseHour && TimeMinute(TimeCurrent())>= FridayCloseMinute))
     {
       for(int i=OrdersTotal()-1; i>=0; i--)
  	    { 
     	   dummyResult = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol()     != s_symbol)    continue;
            if(OrderMagicNumber()!= MAGIC)       continue;

            if(OrderType()==OP_BUY)  { dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_ASK),0,CLR_NONE); continue; }
            if(OrderType()==OP_SELL) { dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(s_symbol,MODE_BID),0,CLR_NONE); continue; }
       }
       return(0);
     }
   }
   
   //
   //
   //
   //
   //
   
   int openedOrders = 0;
   for (i=OrdersTotal()-1; i>=0; i--)
   { 
      dummyResult = OrderSelect(i, SELECT_BY_POS,MODE_TRADES);
         if (OrderSymbol()      != s_symbol) continue;
         if (OrderMagicNumber() != MAGIC)    continue;
           openedOrders++;
   }
   
   //
   //
   //
   //
   //
   
   RefreshRates();
   double trendNow = iCustom(s_symbol,0,"Nlma Hma cross nmc",NlmPeriod,NlmPrice,PctFilter,HmaPeriod,HmaPrice,4,currentbar);
   double trendPre = iCustom(s_symbol,0,"Nlma Hma cross nmc",NlmPeriod,NlmPrice,PctFilter,HmaPeriod,HmaPrice,4,currentbar+1);
   
   ArrayCopyRates(Weekly_Price, Symbol(), 10080);

   WeekHigh  = Weekly_Price[1][3];
   WeekLow   = Weekly_Price[1][2];
   WeekClose = Weekly_Price[1][4];
   WeekRange = WeekHigh - WeekLow;
   WeekPivot = ((WeekHigh + WeekLow + WeekClose)/3);

   WR1 = WeekPivot + (WeekRange * 0.382);
   WS1 = WeekPivot - (WeekRange * 0.382);
   WR2 = WeekPivot + (WeekRange * 0.618);
   WS2 = WeekPivot - (WeekRange * 0.618);
   WR3 = WeekPivot + (WeekRange * 1.000);
   WS3 = WeekPivot - (WeekRange * 1.000);
      
   WM1 = (WS2 + WS3)      * 0.5;
   WM2 = (WS1 + WS2)      * 0.5;
   WM3 = (WeekPivot + WS1)* 0.5;
   WM4 = (WeekPivot + WR1)* 0.5;
   WM5 = (WR1 + WR2)      * 0.5;
   WM6 = (WR2 + WR3)      * 0.5;
      
   W_day_high = Weekly_Price[0][3];
   W_day_low  = Weekly_Price[0][2];
   W_D        = (W_day_high - W_day_low);
   W_Q        = (WeekHigh   - WeekLow);
      
   if (W_Q > 5) {  W_nQ = W_Q;       }
   else         {  W_nQ = W_Q*10000; }

   if (W_D > 5) {  W_nD = W_D;       }
   else         {  W_nD = W_D*10000; }
      
   if (StringSubstr(Symbol(),3,3)=="JPY") { W_nQ=W_nQ/100; W_nD=W_nD/100;  }
   
   //
   //
   //
   //
   //
   
   RefreshRates();
   if (ShowWeeklyFibs==true)
   {
     TimeToStr(TimeGMT());
     if (ObjectFind("WeekPivotLine") != 0)
     { 
       ObjectCreate("WeekPivotLine", OBJ_HLINE,0, iTimeGMT(),WeekPivot);
          ObjectSet("WeekPivotLine", OBJPROP_STYLE, STYLE_SOLID);
          ObjectSet("WeekPivotLine", OBJPROP_WIDTH, 1);
          ObjectSet("WeekPivotLine", OBJPROP_COLOR, Weekly_Pivot);
     }
     else
     {
       ObjectMove("WeekPivotLine", 0, Time[30], WeekPivot);
     }
  
     if (ObjectFind("WeekPivotLabel") != 0)
     {
       ObjectCreate("WeekPivotLabel", OBJ_TEXT, 0, Time[30], WeekPivot);
       ObjectSetText("WeekPivotLabel", "WeeklyPivot", 8, "Arial", Weekly_Pivot);
     }
     else
     {
       ObjectMove("WeekPivotLabel", 0, Time[30], WeekPivot);
     }

     //
     //
     //
     //
     //

     if (Weekly_SR_Levels==true)
     {
       if (ObjectFind("WR1_Line") != 0)
       {
         ObjectCreate("WR1_Line", OBJ_HLINE,0, iTimeGMT(),WR1);
            ObjectSet("WR1_Line", OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet("WR1_Line", OBJPROP_WIDTH, 1);
            ObjectSet("WR1_Line", OBJPROP_COLOR, Weekly_R_Levels);
       }
       else
       {
         ObjectMove("WR1_Line", 0, Time[30], WR1);
       }  
  
       if (ObjectFind("WR1_Label") != 0)
       {
         ObjectCreate("WR1_Label", OBJ_TEXT, 0, Time[30], WR1);
         ObjectSetText("WR1_Label", " Weekly R1", 8, "Arial", Weekly_R_Levels);
       }
       else
       {
         ObjectMove("WR1_Label", 0, Time[30], WR1);
       }

       //--------------------------------------------------------
       //
       //
       //
       //

       if (ObjectFind("WR2_Line") != 0)
       {
         ObjectCreate("WR2_Line", OBJ_HLINE,0, iTimeGMT(),WR2);
            ObjectSet("WR2_Line", OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet("WR2_Line", OBJPROP_WIDTH, 1);
            ObjectSet("WR2_Line", OBJPROP_COLOR, Weekly_R_Levels);
       }
       else
       {
         ObjectMove("WR2_Line", 0, Time[30], WR2);
       }
   
       if (ObjectFind("WR2_Label") != 0)
       {
         ObjectCreate("WR2_Label", OBJ_TEXT, 0, Time[30], WR2);
         ObjectSetText("WR2_Label", " Weekly R2", 8, "Arial", Weekly_R_Levels);
       }
       else
       {
         ObjectMove("WR2_Label", 0, Time[30], WR2);
       }

       //---------------------------------------------------------
       //
       //
       //
       //

       if (ObjectFind("WR3_Line") != 0)
       {
          ObjectCreate("WR3_Line", OBJ_HLINE,0, iTimeGMT(),WR3);
             ObjectSet("WR3_Line", OBJPROP_STYLE, STYLE_SOLID);
             ObjectSet("WR3_Line", OBJPROP_WIDTH, 1);
             ObjectSet("WR3_Line", OBJPROP_COLOR, Weekly_R_Levels);
       }
       else
       {
          ObjectMove("WR3_Line", 0, Time[30], WR3);
       }
   
       if (ObjectFind("WR3_Label") != 0)
       {
          ObjectCreate("WR3_Label", OBJ_TEXT, 0, Time[30], WR3);
          ObjectSetText("WR3_Label", " Weekly R3", 8, "Arial", Weekly_R_Levels);
       }
       else
       {
         ObjectMove("WR3_Label", 0, Time[30], WR3);
       }

       //---------------------------------------------------------
       //
       //
       //
       //

       if (ObjectFind("WS1_Line") != 0)
       {
         ObjectCreate("WS1_Line", OBJ_HLINE,0, iTimeGMT(),WS1);
            ObjectSet("WS1_Line", OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet("WS1_Line", OBJPROP_WIDTH, 1);
            ObjectSet("WS1_Line", OBJPROP_COLOR, Weekly_S_Levels);
       }
       else
       {
         ObjectMove("WS1_Line", 0, Time[30], WS1);
       }
   
       if (ObjectFind("WS1_Label") != 0)
       {
         ObjectCreate("WS1_Label", OBJ_TEXT, 0, Time[30], WS1);
         ObjectSetText("WS1_Label", "Weekly S1", 8, "Arial", Weekly_S_Levels);
       }
       else
       {
         ObjectMove("WS1_Label", 0, Time[30], WS1);
       }

       //---------------------------------------------------------
       //
       //
       //
       //

       if (ObjectFind("WS2_Line") != 0)
       {
          ObjectCreate("WS2_Line", OBJ_HLINE,0, iTimeGMT(),WS2);
             ObjectSet("WS2_Line", OBJPROP_STYLE, STYLE_SOLID);
             ObjectSet("WS2_Line", OBJPROP_WIDTH, 1);
             ObjectSet("WS2_Line", OBJPROP_COLOR, Weekly_S_Levels);
       }
       else
       {
          ObjectMove("WS2_Line", 0, Time[30], WS2);
       }
   
       if (ObjectFind("WS2_Label") != 0)
       {
         ObjectCreate("WS2_Label", OBJ_TEXT, 0, Time[30], WS2);
         ObjectSetText("WS2_Label", "Weekly S2", 8, "Arial", Weekly_S_Levels);
       }
       else
       {
         ObjectMove("WS2_Label", 0, Time[30], WS2);
       }

       //---------------------------------------------------------
       //
       //
       //
       //

       if (ObjectFind("WS3_Line") != 0)
       {
         ObjectCreate("WS3_Line", OBJ_HLINE,0, iTimeGMT(),WS3);
            ObjectSet("WS3_Line", OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet("WS3_Line", OBJPROP_WIDTH, 1);
            ObjectSet("WS3_Line", OBJPROP_COLOR, Weekly_S_Levels);
       }
       else
       {
         ObjectMove("WS3_Line", 0, Time[30], WS3);
       }
      
       if (ObjectFind("WS3_Label") != 0)
       {
         ObjectCreate("WS3_Label", OBJ_TEXT, 0, Time[30], WS3);
         ObjectSetText("WS3_Label", "Weekly S3", 8, "Arial", Weekly_S_Levels);
       }
       else
       {
         ObjectMove("WS3_Label", 0, Time[30], WS3);
       }
      }
    }

    //-----------------------------------------------
    //
    //
    //
    //

    RefreshRates();
    if (Weekly_Mid_Levels==True)
    {
      if (ObjectFind("WM1_Line") != 0)
      { 
        ObjectCreate("WM1_Line", OBJ_HLINE,0, iTimeGMT(),WM1);
           ObjectSet("WM1_Line", OBJPROP_COLOR, Weekly_Mid_Level);
           ObjectSet("WM1_Line", OBJPROP_STYLE, STYLE_DASH);
      }
      else
      {
         ObjectMove("WM1_Line", 0, Time[25], WM1);
      }

      if (ObjectFind("WM1_Label") != 0)
      {
        ObjectCreate("WM1_Label", OBJ_TEXT, 0, Time[25], WM1);
        ObjectSetText("WM1_Label", "WM1", 8, "Arial", Weekly_Mid_Level);
      }
      else
      {
        ObjectMove("WM1_Label", 0, Time[25], WM1);
      }
      
      //-------------------------------------
      //
      //
      //
      //
   
      if (ObjectFind("WM2_Line") != 0)
      { 
        ObjectCreate("WM2_Line", OBJ_HLINE,0, iTimeGMT(),WM2);
           ObjectSet("WM2_Line", OBJPROP_COLOR, Weekly_Mid_Level);
           ObjectSet("WM2_Line", OBJPROP_STYLE, STYLE_DASH);
      }
      else
      {
        ObjectMove("WM2_Line", 0, Time[25], WM2);
      }

      if (ObjectFind("WM2_Label") != 0)
      {
        ObjectCreate("WM2_Label", OBJ_TEXT, 0, Time[25], WM2);
        ObjectSetText("WM2_Label", "WM2", 8, "Arial", Weekly_Mid_Level);
      }
      else
      {
        ObjectMove("WM2_Label", 0, Time[25], WM2);
  
      }
      
      //------------------------------------
      //
      //
      //
      //
   
      if (ObjectFind("WM3_Line") != 0)
      { 
        ObjectCreate("WM3_Line", OBJ_HLINE,0, iTimeGMT(),WM3);
           ObjectSet("WM3_Line", OBJPROP_COLOR, Weekly_Mid_Level);
           ObjectSet("WM3_Line", OBJPROP_STYLE, STYLE_DASH);
      }
      else
      {
        ObjectMove("WM3_Line", 0, Time[25], WM3);
      }

      if (ObjectFind("WM3_Label") != 0)
      {
        ObjectCreate("WM3_Label", OBJ_TEXT, 0, Time[25], WM3);
        ObjectSetText("WM3_Label", "WM3", 8, "Arial", Weekly_Mid_Level);
      }
      else
      {
        ObjectMove("WM3_Label", 0, Time[25], WM3);
      } 
       
      //-------------------------------------
      //
      //
      //
      //
   
      if (ObjectFind("WM4_Line") != 0)
      { 
        ObjectCreate("WM4_Line", OBJ_HLINE,0, iTimeGMT(),WM4);
           ObjectSet("WM4_Line", OBJPROP_COLOR, Weekly_Mid_Level);
           ObjectSet("WM4_Line", OBJPROP_STYLE, STYLE_DASH);
      }
      else
      {
        ObjectMove("WM4_Line", 0, Time[25], WM4);
      }

      if (ObjectFind("WM4_Label") != 0)
      {
        ObjectCreate("WM4_Label", OBJ_TEXT, 0, Time[25], WM4);
        ObjectSetText("WM4_Label", "WM4", 8, "Arial", Weekly_Mid_Level);
      }
      else
      {
        ObjectMove("WM4_Label", 0, Time[25], WM4);
      }   
      
      //--------------------------------------
      //
      //
      //
      //
   
      if (ObjectFind("WM5_Line") != 0)
      { 
        ObjectCreate("WM5_Line", OBJ_HLINE,0, iTimeGMT(),WM5);
           ObjectSet("WM5_Line", OBJPROP_COLOR, Weekly_Mid_Level);
           ObjectSet("WM5_Line", OBJPROP_STYLE, STYLE_DASH);
      }
      else
      {
        ObjectMove("WM5_Line", 0, Time[25], WM5);
      }

      if (ObjectFind("WM5_Label") != 0)
      {
        ObjectCreate("WM5_Label", OBJ_TEXT, 0, Time[25], WM5);
        ObjectSetText("WM5_Label", "WM5", 8, "Arial", Weekly_Mid_Level);
      }
      else
      {
        ObjectMove("WM5_Label", 0, Time[25], WM5);
      }
      
      //---------------------------------------
      //
      //
      //
      //
   
      if (ObjectFind("WM6_Line") != 0)
      { 
        ObjectCreate("WM6_Line", OBJ_HLINE,0, iTimeGMT(),WM6);
           ObjectSet("WM6_Line", OBJPROP_COLOR, Weekly_Mid_Level);
           ObjectSet("WM6_Line", OBJPROP_STYLE, STYLE_DASH);
      }
      else
      {
        ObjectMove("WM6_Line", 0, Time[25], WM6);
      }

      if (ObjectFind("WM6_Label") != 0)
      {
        ObjectCreate("WM6_Label", OBJ_TEXT, 0, Time[25], WM6);
        ObjectSetText("WM6_Label", "WM6", 8, "Arial", Weekly_Mid_Level);
      }
      else
      {
        ObjectMove("WM6_Label", 0, Time[25], WM6);
      } 
 
   }
   
   //
   //
   //
   //
   //
   
   if (UseHourTrade)
   {
     if(!checkTimeLimits(StartHour,StartMinute,0,EndHour,EndMinute,0,TimeCurrent())) { tc = "Non-Trading Hours"; return(0); }}
     else                                                                              tc = "Trading Hours";
   //
   //
   //
   //
   //
   
   if (openedOrders <= 0)
   { 
     if (trendNow>0 && trendPre<=0 && Bid<=WS1 && Bid>=WS3)  { OpenBuy();  return(0); }
     if (trendNow<0 && trendPre>=0 && Bid>=WR1 && Bid<=WR3)  { OpenSell(); return(0); }  
   }
return (0);
}

//
//
//
//
//

bool checkTimeLimits(uint startHour, uint startMinute, uint startSecond, uint endHour, uint endMinute, uint endSecond, datetime timeToCheck)
{
   bool answer = false;
   MqlDateTime tempTime; TimeToStruct(timeToCheck,tempTime);
      datetime startTime,endTime,checkTime;
               startTime = _ctMinMax(startHour,0,24)    *3600+_ctMinMax(startMinute,0,60) *60+_ctMinMax(startSecond,0,60);
               endTime   = _ctMinMax(endHour,0,24)      *3600+_ctMinMax(endMinute,0,60)   *60+_ctMinMax(endSecond,0,60);
               checkTime = _ctMinMax(tempTime.hour,0,24)*3600+_ctMinMax(tempTime.min,0,60)*60+_ctMinMax(tempTime.sec,0,60);
               
   if (startTime>endTime)
          answer = (checkTime>=startTime || checkTime<=endTime);
   else   answer = (checkTime>=startTime && checkTime<=endTime);
   return(answer);
}
uint _ctMinMax(uint value, uint min, uint max) { return((uint)MathMax(MathMin(value,max),min)); }

//
//
//
//
//

void breakEvenManager() 
{
   double pAsk = Ask; 
   double pBid = Bid; 
   for(int i=OrdersTotal()-1; i>=0; i--)
  	{ 
      dummyResult = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()     != s_symbol) continue;
      if(OrderMagicNumber()!= MAGIC)    continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType()==OP_BUY)
      {
        if (pBid-OrderOpenPrice()>pPoint*BreakEven*pipMultiplier) 
        {
          double BuyStop = OrderOpenPrice()+LockInPips*pPoint*pipMultiplier;
          if (OrderStopLoss() < BuyStop) 
          dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(BuyStop,digit),NormalizeDouble(OrderTakeProfit(),digit),LightGreen);
		    return;
	     }
      }
      
      //
      //
      //
      //
      //
      
      if (OrderType()==OP_SELL)
      {
        if (OrderOpenPrice()-pAsk > pPoint*BreakEven*pipMultiplier) 
        {
           double SellStop = OrderOpenPrice()-LockInPips*pPoint*pipMultiplier;
           if (OrderStopLoss() > SellStop) 
           dummyResult = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(SellStop,digit),NormalizeDouble(OrderTakeProfit(),digit),DarkOrange);
		     return;
        }
      }   
   }
}   

//
//
//
//
//

void TrailingPositionsBuy() { 
   double pBid = Bid; 
   for (int i = OrdersTotal()-1; i >=0 ; i--) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_BUY) { 
              if (TrailAfterBreakEvenOnly) { if(OrderStopLoss()<OrderOpenPrice()) return; }
                if (pBid - OrderOpenPrice()   > lTrailingStop * pPoint * pipMultiplier) { 
                  if (OrderStopLoss() < pBid  - lTrailingStop * pPoint * pipMultiplier) 
                      ModifyStopLoss(   pBid  - lTrailingStop * pPoint * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void TrailingPositionsSell() { 
   double pAsk = Ask; 
   for (int i = 0; i < OrdersTotal(); i++) { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) { 
         if (OrderSymbol() == s_symbol && OrderMagicNumber() == MAGIC) { 
            if (OrderType() == OP_SELL) { 
              if (TrailAfterBreakEvenOnly) { if(OrderStopLoss()>OrderOpenPrice()) return; }
                if (OrderOpenPrice()  - pAsk > sTrailingStop * pPoint * pipMultiplier) { 
                  if (OrderStopLoss() > pAsk + sTrailingStop * pPoint * pipMultiplier || OrderStopLoss() == 0)  
                      ModifyStopLoss(   pAsk + sTrailingStop * pPoint * pipMultiplier); 
               } 
            } 
         } 
      } 
   } 
}

//
//
//
//
//
 
void ModifyStopLoss(double ldStopLoss) 
{ 
   bool fm;
   double minStop = 0;
   double pBid    = Bid;
   double pAsk    = Ask;
   double sl      = MarketInfo(s_symbol,MODE_STOPLEVEL);   
   bool   canGo   = false;
      if (OrderType()==OP_BUY)
            { minStop = pBid-sl*pPoint; canGo = ldStopLoss<=minStop; }
      else  { minStop = pAsk+sl*pPoint; canGo = ldStopLoss>=minStop; }
      if (canGo)
      {
        fm = OrderModify(OrderTicket(),NormalizeDouble(OrderOpenPrice(),digit),NormalizeDouble(ldStopLoss,digit),NormalizeDouble(OrderTakeProfit(),digit),0,CLR_NONE); 
        if (fm == false)
        {
	        int    ErrorCode = GetLastError();
	        string ErrDesc   = ErrorDescription(ErrorCode);
	        string ErrAlert  = StringConcatenate("Trailing Stop Modification - Error ",ErrorCode,": ",ErrDesc);
   	        if (ShowAlerts   == true) Alert(ErrAlert);
            	  string ErrLog = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Ticket: ",OrderTicket()," Stop: ",OrderStopLoss()," Trail: ",ldStopLoss);
      	  Print(ErrLog);
      	}
      }      	
      else Print("Stop loss to close to current price");

}  

//
//
//
//
//

void OpenBuy() 
{ 
    
   double lbStop = 0; if (lStopLoss>0)   lbStop = NormalizeDouble(MarketInfo(s_symbol,MODE_ASK)-lStopLoss  *pPoint*pipMultiplier,digit);
   double lbTake = 0; if (lTakeProfit>0) lbTake = NormalizeDouble(MarketInfo(s_symbol,MODE_ASK)+lTakeProfit*pPoint*pipMultiplier,digit);
   
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return; }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
         dummyResult = OrderSend(s_symbol,OP_BUY,LotsOptimized(),MarketInfo(s_symbol,MODE_ASK),Slippage*pipMultiplier,lbStop,lbTake,ExpertName,MAGIC,0,clOpenBuy); 
   else
   {
         int buyTicket    = OrderSend(s_symbol,OP_BUY,LotsOptimized(),MarketInfo(s_symbol,MODE_ASK),Slippage*pipMultiplier,0,0,ExpertName,MAGIC,0,clOpenBuy);		    		    
         if (buyTicket   >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),lbStop,lbTake,0,CLR_NONE);
         
         if (buyOrderMod  == false)
         {
         
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Buy Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Bid: ",MarketInfo(s_symbol,MODE_BID)," Ticket: ",buyTicket," Stop: ",lbStop," Profit: ",lbTake);
           Print(ErrLog);
         }
    }		       

}

//
//
//
//
//

void OpenSell() 
{ 

   double lsStop = 0; if (sStopLoss>0)   lsStop = NormalizeDouble(MarketInfo(s_symbol,MODE_BID)+sStopLoss  *pPoint*pipMultiplier,digit);
   double lsTake = 0; if (sTakeProfit>0) lsTake = NormalizeDouble(MarketInfo(s_symbol,MODE_BID)-sTakeProfit*pPoint*pipMultiplier,digit);
  
   if (AccountFreeMargin() < (100 * Lots)) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return; }
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker)
         dummyResult = OrderSend(s_symbol,OP_SELL,LotsOptimized(),MarketInfo(s_symbol,MODE_BID),Slippage*pipMultiplier,lsStop,lsTake,ExpertName,MAGIC,0,clOpenSell); 
   else
   {
         int sellTicket    = OrderSend(s_symbol,OP_SELL,LotsOptimized(),MarketInfo(s_symbol,MODE_BID),Slippage*pipMultiplier,0,0,ExpertName,MAGIC,0,clOpenSell);		    		    
         if (sellTicket    >= 0)
         bool sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),lsStop,lsTake,0,CLR_NONE);
         
         if (sellOrderMod  == false)
         {
           int    ErrorCode = GetLastError();
           string ErrDesc   = ErrorDescription(ErrorCode);

           string ErrAlert  = StringConcatenate("Modify Sell Order - Error ",ErrorCode,": ",ErrDesc);
           if (ShowAlerts   == true) Alert(ErrAlert);

           string ErrLog    = StringConcatenate("Ask: ",MarketInfo(s_symbol,MODE_ASK)," Bid: ",MarketInfo(s_symbol,MODE_BID)," Ticket: ",sellTicket," Stop: ",lsStop," Profit: ",lsTake);
           Print(ErrLog);
          }
    }		       
} 

//
//
//
//
//

void CheckForClose()  
{
   RefreshRates();
   double trendNow = iCustom(s_symbol,0,"Nlma Hma cross nmc",NlmPeriod,NlmPrice,PctFilter,HmaPeriod,HmaPrice,4,currentbar);
   double trendPre = iCustom(s_symbol,0,"Nlma Hma cross nmc",NlmPeriod,NlmPrice,PctFilter,HmaPeriod,HmaPrice,4,currentbar+1);
   
   //
   //
   //
   //
   //
   
   for (int i = 0;i < OrdersTotal(); i++)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false)  break;
      if (OrderMagicNumber()!= MAGIC)                         continue;
      if (OrderSymbol()     != s_symbol)                      continue;
      
      //
      //
      //
      //
      //
      
      if (OrderType() == OP_BUY)
      {
        if (trendNow < 0 && trendPre >= 0 && Bid>=WR1 && Bid<=WR3)
        {
          bool buyClose = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage*pipMultiplier,clCloseBuy);
          if (buyClose == false)
          {
            int ErrorCode   = GetLastError();
            string ErrDesc  = ErrorDescription(ErrorCode);

            string ErrAlert = StringConcatenate("Close Buy Order - Error ",ErrorCode,": ",ErrDesc);
            if (ShowAlerts  == true) Alert(ErrAlert);

            string ErrLog   = StringConcatenate("Bid: ",Bid," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
      
      //
      //
      //
      //
      //
        
      if (OrderType() == OP_SELL)
      {
        if (trendNow > 0 && trendPre <= 0 && Bid<=WS1 && Bid>=WS3)
        {
          bool sellClose = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage*pipMultiplier,clCloseSell); 
          if (sellClose  == false)
          {
            ErrorCode = GetLastError();
            ErrDesc   = ErrorDescription(ErrorCode);

            ErrAlert  = StringConcatenate("Close Sell Order - Error ",ErrorCode,": ",ErrDesc);
            if (ShowAlerts == true) Alert(ErrAlert);

            ErrLog   = StringConcatenate("Ask: ",Ask," Lots: ",OrderLots(), " Ticket: ",OrderTicket());
            Print(ErrLog);
          }
        }
        break;
      }
   }
}


//
//
//
//
//

double LotsOptimized()
{
   double lot_min  = MarketInfo(s_symbol,MODE_MINLOT);
   double lot_max  = MarketInfo(s_symbol,MODE_MAXLOT);
   double lot_step = MarketInfo(s_symbol,MODE_LOTSTEP);
   double contract = MarketInfo(s_symbol,MODE_LOTSIZE);
   double lot      = Lots;
   int    orders   = HistoryTotal();     // history orders total
   int    losses   = 0;                  // number of losses orders without a break
   
   //
   //
   //
   //
   //
   
   if(lot_min < 0.0 || lot_max <= 0.0 || lot_step <= 0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   if (MaximumRisk > 0)
   {
   lot = NormalizeDouble(AccountFreeMargin() * MaximumRisk * AccountLeverage()/contract,2);
   }
   
   if(DecreaseFactor>0)
   {
      for(int i=orders-1;i>=0;i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
      if(OrderSymbol()!= s_symbol || OrderType() > OP_SELL) continue;
      
      //
      //
      //
      //
      //
      
      if(OrderProfit() > 0) break;
      if(OrderProfit() < 0) losses++;
      }
   if(losses>1) lot=NormalizeDouble(lot - lot * losses/DecreaseFactor,2);
   }
   
   //
   //
   //
   //
   //
   
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
   
return(lot);
} 

//
//
//
//
//

int GetMagic() 
{

   if (StringFind(s_symbol, "CADJPY") >= 0) return(2222221);
   if (StringFind(s_symbol, "CADCHF") >= 0) return(2222222);
   
   if (StringFind(s_symbol, "GOLD"  ) >= 0) return(2222231);
   if (StringFind(s_symbol, "SILVER") >= 0) return(2222232);
   
   if (StringFind(s_symbol, "NZDJPY") >= 0) return(2222241);
   if (StringFind(s_symbol, "NZDUSD") >= 0) return(2222242);
   
   if (StringFind(s_symbol, "CHFJPY") >= 0) return(2222251);
   
   if (StringFind(s_symbol, "EURAUD") >= 0) return(2222261);
   if (StringFind(s_symbol, "EURCAD") >= 0) return(2222262);
   if (StringFind(s_symbol, "EURUSD") >= 0) return(2222263);
   if (StringFind(s_symbol, "EURGBP") >= 0) return(2222264);
   if (StringFind(s_symbol, "EURCHF") >= 0) return(2222265);
   if (StringFind(s_symbol, "EURNZD") >= 0) return(2222266);
   if (StringFind(s_symbol, "EURJPY") >= 0) return(2222267);
   
   if (StringFind(s_symbol, "GBPUSD") >= 0) return(2222271);
   if (StringFind(s_symbol, "GBPCHF") >= 0) return(2222272);
   if (StringFind(s_symbol, "GBPJPY") >= 0) return(2222273);
   
   if (StringFind(s_symbol, "USDCHF") >= 0) return(2222281);
   if (StringFind(s_symbol, "USDJPY") >= 0) return(2222282);
   if (StringFind(s_symbol, "USDCAD") >= 0) return(2222283);

   if (StringFind(s_symbol, "AUDUSD") >= 0) return(2222291);
   if (StringFind(s_symbol, "AUDNZD") >= 0) return(2222292);
   if (StringFind(s_symbol, "AUDCAD") >= 0) return(2222293);
   if (StringFind(s_symbol, "AUDCHF") >= 0) return(2222294);
   if (StringFind(s_symbol, "AUDJPY") >= 0) return(2222295);
   
return(ManualMagic);
}

//
//
//
//
//

//
//
//
//
//

double TimeZoneLocale()
{     
      //
      //
      //
      //
      //

	   switch(GetTimeZoneInformation(TZInfoArray))
	   {
	        case TIME_ZONE_ID_UNKNOWN: 
	        Print("Error obtaining PC timezone from GetTimeZoneInformation in kernel32.dll. Returning 0");
		     return(0);

	        case TIME_ZONE_ID_STANDARD:
		     return(TZInfoArray[0]/(-60.0));
	
	        case TIME_ZONE_ID_DAYLIGHT:
		     return((TZInfoArray[0]+TZInfoArray[42])/(-60.0));
		
 	        default:
		     Print("Unkown return value from GetTimeZoneInformation in kernel32.dll. Returning 0");
		     return(0);
	   }
}

// 
//
//
//
//

double TimeZoneServer()
{
	int ServerLocalDiffMinutes = (TimeCurrent()-TimeLocal())/60;
	int HalfHourDiff           = MathRound(ServerLocalDiffMinutes/30.0);
	
	//
	//
	//
	//
	//
	
	ServerLocalDiffMinutes = HalfHourDiff*30;
	
return(TimeZoneLocale() + ServerLocalDiffMinutes/60.0);
}

// 
//
//
//
//

datetime iTimeGMT()
{

	    datetime GmtFromLocale = TimeLocal()   - TimeZoneLocale()*3600;
	    datetime GmtFromServer = TimeCurrent() - TimeZoneServer()*3600;

       if (GmtFromLocale>GmtFromServer + 300) {  return(GmtFromLocale); }
	    else                                   {  return(GmtFromServer); }	
}

//
//
//
//
//

void ChartComment()
{
   RefreshRates();
   if (IsTesting() && !IsVisualMode()) return;
   if (IsTesting()) return;
   
   string symbol   = Symbol(); if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
  	double modifier = 1;
  	int    digits   = MarketInfo(symbol,MODE_DIGITS);
   if (digits==3 || digits==5) modifier = 10.0;
   
   //
  	//
  	//
  	//
  	//
   
   if(MarketInfo(symbol,MODE_SWAPLONG) > 0)                                string    swap="longs,";
                                                                           else      swap="shorts.";
   if(MarketInfo(symbol,MODE_SWAPLONG) < 0 && MarketInfo(symbol,MODE_SWAPSHORT) < 0) swap="your broker. ";
   
   //
   //
   //
   //
   //
   
   string strLocal  = TimeToStr(TimeLocal(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	string strServer = TimeToStr(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	string strGMT    = TimeToStr(TimeGMT(),TIME_DATE|TIME_MINUTES|TIME_SECONDS);
	
	string strLocalTimeZone;
	if (TimeZoneLocale() >  0)  strLocalTimeZone  = StringConcatenate("Local timezone: GMT plus  ", TimeZoneLocale()," hours");
	if (TimeZoneLocale() == 0)  strLocalTimeZone  = "Local timezone: GMT";
	if (TimeZoneLocale() <  0)  strLocalTimeZone  = StringConcatenate("Local timezone: GMT minus ",-TimeZoneLocale()," hours");
	
	string strServerTimeZone;
	if (TimeZoneServer() >  0) strServerTimeZone = StringConcatenate("Server timezone: GMT plus  ", TimeZoneServer()," hours");
	if (TimeZoneServer() == 0) strServerTimeZone = "Server timezone: GMT";
  	if (TimeZoneServer() <  0) strServerTimeZone = StringConcatenate("Server timezone: GMT minus ",-TimeZoneServer()," hours");
   
   //
   //
   //
   //
   //
   
   string sComment   = "";
   string sp         = "------------------------------------------------------------\n";
   string NL         = "\n";
   
   sComment = sComment + sp;
   sComment = sComment+ "Expert Name : "+ExpertName+NL;
   sComment = sComment+ "EA Version  : "+Version+NL;
   sComment = sComment+ sp;
   sComment = sComment+ "Market Analysis" + NL;
   sComment = sComment+ "Swap favors " + swap + NL; 
   sComment = sComment+ "Swap Long      = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPLONG),2) + NL; 
   sComment = sComment+ "Swap Short     = " + DoubleToStr(MarketInfo(symbol,MODE_SWAPSHORT),2) + NL; 
   sComment = sComment+ "Current Spread = " + DoubleToStr(MarketInfo(symbol,MODE_SPREAD)/ modifier,2) + NL; 
   sComment = sComment+ sp;
   sComment = sComment+ "Time Information" + NL;
   sComment = sComment+ strLocalTimeZone  + NL;
   sComment = sComment+ strServerTimeZone + NL;
   sComment = sComment+ "PC Local Time = " +strLocal+ NL;
   sComment = sComment+ "Broker Server Time =  " +strServer+ NL;
   sComment = sComment+ "GMT Time =  " +strGMT+ NL;
   sComment = sComment+ "Time Condition: " + tc + NL;
   sComment = sComment+ sp;
   sComment = sComment+ "Have a great trading day" + NL;
   sComment = sComment+ sp; 
   
Comment(sComment);
}
